accounts/urls.py
from django.urls import path
from django.contrib.auth import views as auth_views
from accounts.views import SignUpView

urlpatterns = [
    path("login/", auth_views.LoginView.as_view(), name="login"),
    path("logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("signup/", SignUpView.as_view(), name="signup"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("admin/", admin.site.urls),
    path("", RedirectView.as_view(pattern_name="home"), name="home"),
    path("receipts/", include("receipts.urls")),
    path("accounts/", include("accounts.urls")),
]

receipts/urls.py
from django.urls import path
from receipts.views import (
    AccountCreateView,
    AccountListView,
    ExpenseCategoryCreateView,
    ExpenseCategoryListView,
    ReceiptListView,
    ReceiptCreateView,
)

urlpatterns = [
    path("", ReceiptListView.as_view(), name="home"),
    path("create/", ReceiptCreateView.as_view(), name="create_receipt"),
    path(
        "categories/",
        ExpenseCategoryListView.as_view(),
        name="show_categories",
    ),
    path("accounts/", AccountListView.as_view(), name="show_accounts"),
    path(
        "categories/create/",
        ExpenseCategoryCreateView.as_view(),
        name="create_category",
    ),
    path(
        "accounts/create/", AccountCreateView.as_view(), name="create_account"
    ),
]

accounts/models.py
from django.db import models

# Create your models here.

receipts/models.py
from django.db import models
from django.contrib.auth.models import User


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50, unique=True)
    owner = models.ForeignKey(
        User, related_name="categories", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100, unique=True)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        User, related_name="accounts", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200, unique=True)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateTimeField()
    purchaser = models.ForeignKey(
        User, related_name="receipts", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        ExpenseCategory, related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        Account, related_name="receipts", on_delete=models.CASCADE, null=True
    )

accounts/views.py
from django.shortcuts import render

from django.contrib.auth.forms import UserCreationForm
from django.urls import reverse_lazy
from django.views import generic


class SignUpView(generic.CreateView):
    form_class = UserCreationForm
    success_url = reverse_lazy("home")
    template_name = "registration/signup.html"

receipts/views.py
from django.shortcuts import render, redirect
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView


from receipts.models import Account, ExpenseCategory, Receipt
from django.contrib.auth.mixins import LoginRequiredMixin


class ReceiptListView(LoginRequiredMixin, ListView):
    model = Receipt
    template_name = "receipts/list.html"

    def get_queryset(self):
        return Receipt.objects.filter(purchaser=self.request.user)


class ReceiptCreateView(LoginRequiredMixin, CreateView):
    model = Receipt
    template_name = "receipts/create.html"
    fields = ["vendor", "total", "tax", "date", "category", "account"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.purchaser = self.request.user
        item.save()
        return redirect("home")


class ExpenseCategoryListView(LoginRequiredMixin, ListView):
    model = ExpenseCategory
    template_name = "expense_categories/list.html"

    def get_queryset(self):
        return ExpenseCategory.objects.filter(owner=self.request.user)


class ExpenseCategoryCreateView(LoginRequiredMixin, CreateView):
    model = ExpenseCategory
    template_name = "expense_categories/create.html"
    fields = ["name"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("show_categories")


class AccountListView(LoginRequiredMixin, ListView):
    model = Account
    template_name = "accounts/list.html"

    def get_queryset(self):
        return Account.objects.filter(owner=self.request.user)


class AccountCreateView(LoginRequiredMixin, CreateView):
    model = Account
    template_name = "accounts/create.html"
    fields = ["name", "number"]

    def form_valid(self, form):
        item = form.save(commit=False)
        item.owner = self.request.user
        item.save()
        return redirect("show_accounts")

accounts/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Title here</title>
</head>
<body>
  <header>
    <nav>
      <ul>
        {% if user.is_authenticated %}
        <li><a href="{% url 'logout' %}">Logout</a></li>
        <li><a href="{% url 'home' %}">Receipts</a></li>
        <li><a href="{% url 'show_accounts' %}">Accounts</a></li>
        <li><a href="{% url 'show_categories' %}">Categories</a></li>
        <li><a href="{% url 'create_receipt' %}">Create receipt</a></li>
        <li><a href="{% url 'create_account' %}">Create account</a></li>
        <li><a href="{% url 'create_category' %}">Create category</a></li>
        {% else %}
        <li><a href="{% url 'login' %}">Login</a></li>
        <li><a href="{% url 'signup' %}">Sign Up</a></li>
        {% endif %}
      </ul>
    </nav>
  </header>

  {% block content %}
  {% endblock %}

</body>
</html>

receipts/templates/accounts/create.html
{% extends '../base.html' %}

{% block content %}

<main>
  <div>
    <h1>Create Account</h1>
      <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button>Create</button>
      </form>
  </div>
</main>

{% endblock %}

receipts/templates/accounts/list.html
{% extends '../base.html' %}

{% block content %}

<main>
  <h1>My Receipts</h1>
  <table>
    <thead>
      <tr>
        <th>Name</th>
        <th>Number</th>
        <th>Number of receipts</th>
      </tr>
    </thead>
    <tbody>
      {% for account in account_list %}
      <tr>
        <td>{{ account.name }}</td>
        <td>{{ account.number }}</td>
        <td>{{ account.receipts.all|length }}</td>
      </tr>
      {% endfor %}
    </tbdody>
  </table>

</main>

{% endblock %}

receipts/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Title here</title>
</head>
<body>
  <header>
    <nav>
      <ul>
        {% if user.is_authenticated %}
        <li><a href="{% url 'logout' %}">Logout</a></li>
        <li><a href="{% url 'home' %}">Receipts</a></li>
        <li><a href="{% url 'show_accounts' %}">Accounts</a></li>
        <li><a href="{% url 'show_categories' %}">Categories</a></li>
        <li><a href="{% url 'create_receipt' %}">Create receipt</a></li>
        <li><a href="{% url 'create_account' %}">Create account</a></li>
        <li><a href="{% url 'create_category' %}">Create category</a></li>
        {% else %}
        <li><a href="{% url 'login' %}">Login</a></li>
        <li><a href="{% url 'signup' %}">Sign Up</a></li>
        {% endif %}
      </ul>
    </nav>
  </header>

  {% block content %}
  {% endblock %}

</body>
</html>

receipts/templates/expense_categories/create.html
{% extends '../base.html' %}

{% block content %}

<main>
  <div>
    <h1>Create Category</h1>
      <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button>Create</button>
      </form>
  </div>
</main>

{% endblock %}

receipts/templates/expense_categories/list.html
{% extends '../base.html' %}

{% block content %}

<main>
  <h1>Expense Categories</h1>
  <table>
    <thead>
      <tr>
        <th>Name</th>
        <th>Number of receipts</th>
      </tr>
    </thead>
    <tbody>
      {% for category in expensecategory_list %}
      <tr>
        <td>{{ category.name }}</td>
        <td>{{ category.receipts.all|length}}</td>
      </tr>
      {% endfor %}
    </tbdody>
  </table>

</main>

{% endblock %}

receipts/templates/receipts/create.html
{% extends '../base.html' %}

{% block content %}

<main>
  <div>
    <h1>Create Receipt</h1>
      <form method="POST" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button>Create</button>
      </form>
  </div>
</main>

{% endblock %}

receipts/templates/receipts/list.html
{% extends '../base.html' %}

{% block content %}

<main>
  <h1>My Receipts</h1>
  <table>
    <thead>
      <tr>
        <th>Vendor</th>
        <th>Total</th>
        <th>Tax</th>
        <th>Date</th>
        <th>Category</th>
        <th>Account</th>
      </tr>
    </thead>
    <tbody>
      {% for receipt in receipt_list %}
      <tr>
        <td>{{ receipt.vendor }}</td>
        <td>{{ receipt.total }}</td>
        <td>{{ receipt.tax }}</td>
        <td>{{ receipt.date|date:"m/d/Y" }}</td>
        <td>{{ receipt.category }}</td>
        <td>{{ receipt.account }}</td>
      </tr>
      {% endfor %}
    </tbdody>
  </table>

</main>

{% endblock %}